#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TherionTreasureCFG.h"
std::auto_ptr<Fish_TherionTreasureCFG> Fish_TherionTreasureCFG::msSingleton(nullptr);

int Fish_TherionTreasureCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TherionTreasureCFGData* Fish_TherionTreasureCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TherionTreasureCFGData>& Fish_TherionTreasureCFG::GetMapData()
{
	return mMapData;
}

void Fish_TherionTreasureCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TherionTreasureCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TherionTreasureCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mDrawType = element->IntAttribute("DrawType");
		{
			const char* RosefinchRate = element->Attribute("RosefinchRate");
			std::vector<std::string> vecRosefinchRate;
			boost::split(vecRosefinchRate, RosefinchRate, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRosefinchRate.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRosefinchRate[i].c_str(), &temp))
				{
					data.mRosefinchRate.push_back(temp);
				}
			}
		}
		data.mRosefinchWeight = element->IntAttribute("RosefinchWeight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TherionTreasureCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TherionTreasureCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TherionTreasureCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TherionTreasureCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TherionTreasureCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "DrawType", data.mDrawType);
		LuaCfgHelper::readVectorInt(L, "RosefinchRate", data.mRosefinchRate);
		LuaCfgHelper::readInt(L, "RosefinchWeight", data.mRosefinchWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TherionTreasureCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TherionTreasureCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TherionTreasureCFG* Fish_TherionTreasureCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TherionTreasureCFG());
	}
	return msSingleton.get();
}

void Fish_TherionTreasureCFG::Release()
{
	msSingleton.reset(nullptr);
}
